
//  star begin/endShape points
int[] x = {50, 61, 83, 69, 71, 50, 29, 31, 17, 39};
int[] y = {18, 37, 43, 60, 82, 73, 82, 60, 43, 37};

//  number of stars
int stars = 50;


float[] posX = new float[stars];
float[] posY = new float[stars];
float[] starXrate = new float[stars];
float[] starYrate = new float[stars];

float bkR = 255;
float bkG = 125;
float bkB = 0;

float bkRrate = -.2;
float bkGrate = -.5;
float bkBrate = .7;

void setup () {
  size(600, 600);
  smooth();
  fill(254, 253, 17);
  
  // set initial positions for stars
  for (int g = 0; g < stars; g++) {
    posX[g] = random(width-72);
    posY[g] = random(height-83);
  }
  
  // set initial speed for each star
  for (int f = 0; f < stars; f++) {
    starXrate[f] = random(-2.0, 2.0);
    starYrate[f] = random(-2.0, 2.0);
  }

}



void draw () {
  // changes background gradually
  bkR += bkRrate;
  bkG += bkGrate;
  bkB += bkBrate;
  
  // sets new position of stars by adding the rate of change of each star to it's previous position
  for (int h = 0; h < stars; h++) {
    posX[h] += starXrate[h];
    posY[h] += starYrate[h];
  }
  
  background(bkR, bkG, bkB);
  
  // draws stars
  for (int i = 0; i < stars; i++) {
    beginShape();
    // Reads one array element every time through the for()
    for (int j = 0; j < x.length; j++) {
      vertex(x[j]+posX[i], y[j]+posY[i]);
      // bounce X
      if ((x[j]+ posX[i]) > width || (x[j]+posX[i]) < 0) {
        starXrate[i] = starXrate[i] * -1;
      }
      // bounce Y
      if ((y[j]+ posY[i]) > height || (y[j]+posY[i]) < 0) {
        starYrate[i] = starYrate[i] * -1;
      }
    }

    endShape(CLOSE);

  }
  


    
  
  // constrains colors between 0 and 255
  if (bkR >= 255 || bkR <= 0) {
    bkRrate = bkRrate * -1;
  }
  if (bkG >= 255 || bkG <= 0) {
    bkGrate = bkGrate * -1;
  }
  if (bkB >= 255 || bkB <= 0) {
    bkBrate = bkBrate * -1;
  }
  
}

/*
// realligns the stars on mouse click
void mousePressed() {
    posX[0] = width/5;
    posY[0] = height/10;
    int i = 1;
    for (int a = 0; a < 10; a += 1) {
      posX[i] = width/5;
      for (int b = 0; b < 10; b += 1) {
        posX[i] = posX[i-1] + a;
        posY[i] = posY[i-1] + b;
        i += 1;
        println(i);
        println("posX: "+posX[i]);
      }
    }
 
    
  }
 */   
    
    

